﻿--[[
Title: myBigIgnite
Author: Istaran | Medivh - EU
myBigIgnite	is licensed under Creative Common CC BY-NC-SA 3.0. See: http://creativecommons.org/licenses/by-nc-sa/3.0/
Inspired by IgniteTracker by Siffin | Korgath - US. Default texture reworked from IgniteTracker.
]]



if select(2, UnitClass("player")) ~= "MAGE" then
   return
end

myBigIgnite = LibStub("AceAddon-3.0"):NewAddon("myBigIgnite", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("myBigIgnite", true)
local LSM = LibStub("LibSharedMedia-3.0")
local ACR = LibStub("AceConfigRegistry-3.0")

local pairs, type, tonumber, tostring, print, tinsert, wipe = pairs, type, tonumber, tostring, print, tinsert, wipe
local _

local myBigIgnite = myBigIgnite
local mBI = myBigIgnite
mBI.addonV = GetAddOnMetadata("myBigIgnite", "Version")
mBI.dbRev = 5

mBI.F = {}																									-- frame container
mBI.spellEnabled = {}																						-- tables handling user defined tracked spells
mBI.remainTime = {}
mBI.spellName = {}
mBI.spellIcon = {}
mBI.spellOrder = {}
mBI.locName = {}

mBI.cD = "|cffFF8000"																						-- mBI color scheme
mBI.cL = "|cffFFE680"
mBI.cC = "|cffFFD101"

mBI.spellID = {																								-- spell ID table
	ignite = 12654,
	livingBomb = 44457,
	pyroblast = 11366,
	pyroHS = 92315,
	ffbolt = 44614,
	combustion = 11129,
	fireball = 133,
	fireblast = 2136,
	impact = 11103,
}	


-------------------------------------------------------------------------------------------------------------------------------------------
--Default settings

mBI.defaults = {
	profile = {
		anchorFrame = {
			coord = {
				xcd = UIParent:GetWidth() / 2,
				ycd = UIParent:GetHeight() / 2,
			},
			strata = 2,
		},
		mainFrame = {
			hiding = {
				noCombat = false,
				noIgnite = false,
				combuCD = false,
				combuCDTime = 0,
			},
			align = "CENTER",
			textSize = 12,
			textFont = "Arial Narrow",
			textFormat = "normal",
			textShadow = true,
			bgEnabled = true,
			bdEnabled = true,
			bgTexture = "Blizzard Tooltip",
			bdTexture = "Solid",
			bdSize = 0.75,
			inset = 0.75,
			textAlign = "CENTER",
			textOffsetX = 1.5,
			textOffsetY = 0,
			lowIg = {
				textFlag = "NONE",
				txtTObg = false,
				txtTObd = false,
				bgTObd = false,
				textColor = {
					r = 1,
					g = 0.5,
					b = 0,
					a = 1,
				},			
				bgColor = {
					r = 1,
					g = 0.5,
					b = 0,
					a = 1,
				},
				bdColor = {
					r = 1,
					g = 0.5,
					b = 0,
					a = 1,
				},
			},
			midIg = {
				mult = 1.2,
				textFlag = "NONE",
				txtTObg = false,
				txtTObd = false,	
				bgTObd = false,
				textColor = {
					r = 0.5,
					g = 0.5,
					b = 1,
					a = 1,
				},			
				bgColor = {
					r = 0.5,
					g = 0.5,
					b = 1,
					a = 1,
				},
				bdColor = {
					r = 0.5,
					g = 0.5,
					b = 1,
					a = 1,
				},				
			},
			highIg = {
				mult = 1.4,
				textFlag = "NONE",
				txtTObg = false,
				txtTObd = false,
				bgTObd = false,			
				textColor = {
					r = 0,
					g = 1,
					b = 0,
					a = 1,
				},			
				bgColor = {
					r = 0,
					g = 1,
					b = 0,
					a = 1,
				},
				bdColor = {
					r = 0,
					g = 1,
					b = 0,
					a = 1,
				},
			},
			impactIg = {
				mult = 1.2,
				textFlag = "NONE",
				txtTObg = false,
				txtTObd = false,
				bgTObd = false,			
				textColor = {
					r = 1,
					g = 1,
					b = 0,
					a = 1,
				},			
				bgColor = {
					r = 1,
					g = 1,
					b = 0,
					a = 1,
				},
				bdColor = {
					r = 1,
					g = 1,
					b = 0,
					a = 1,
				},
			},
		},
		iconFrame = {
			enabled = false,
			side = "LEFT",
			sizeFactor = 1,
			type = "normal",
			bdSize = 0.5,
			dynamic = true,
			filler = "fb",
			impactIcon = false,
		},
		titleFrame = {
			enabled = false,
		},
		igniteTimer = {
			enabled = true,
			mult = 0.9,
			ofx = 0,
			ofy = -0.25,
			reverse = false,
			useGeneralBackground = false,
			texture = "BantoBar",
			redZone = 1,
			alpha = 0.8,
			specificColor = {
				enabled = false,
				color = {
					r = 0,
					g = 0,
					b = 0,
				},
			},
			redZoneColor = {
				r = 1,
				g = 0,
				b = 0,
			},
		},
		-- hudFrame = {
			-- enabled = false,
			-- ycoord = 200,
			-- sizeFactor = 1,
			-- file = "default",
			-- midIg = {
				-- enabled = false,
				-- color = {
					-- r = 1,
					-- g = 1,
					-- b = 1,
					-- a = 1,
				-- },
			-- },
			-- highIg = {
				-- color = {
					-- r = 1,
					-- g = 1,
					-- b = 1,
					-- a = 1,
				-- },
			-- },
		-- },
		spellTracking = {
			ignite = {
				enabled = true,
				order = 4,
			},
			livingBomb = {
				enabled = true,
				order = 1,
			},
			pyroblast = {
				enabled = false,
				order = 3,
			},
			ffbolt = {
				enabled = false,
				order = 2,
			},
		},
		values = {
			igThreshold = 0,
			igPerctEnabled = true,
			igPerct = 0.75,
			impactPerctEnabled = true,
			impactPerct = 0.75,
		},
		settings = {
			lag = 0.5,
			lagVisual = false,
			lagColor = {
				r = 1,
				g = 0,
				b = 0,
			},
			lagVisualType = {
				text = true,
				bg = true,
				bd = true,
			},
			refresh = 0.1,
			refreshCM = 1,
			splashMsg = true,
			combuTrack = true,
			impactMode = true,
		},
	},
}


-------------------------------------------------------------------------------------------------------------------------------------------
-- housekeeping functions

local function getColor(t)
	return t.r, t.g, t.b, t.a
end

local function deepCopy(src)
	local res = {}
    for k, v in pairs(src) do
        if type(v) == "table" then
            v = deepCopy(v)
        end
        res[k] = v
    end
    return res
end

local function round(number, dec)
	return math.floor(number * 10^dec + 0.5) / 10^dec
end

local function formatText(txt)
	if type(txt) == "number" then
		if mBI.db.profile.mainFrame.textFormat == "condensed" then
			txt = round(txt / 1000, 1) .. "k"
		end
	end
	return txt
end


-------------------------------------------------------------------------------------------------------------------------------------------
-- Current spec checking / mBI loading / config loading if necessary

function myBigIgnite:OnEnable()
	self:RegisterEvent("PLAYER_TALENT_UPDATE", "SpecCheck")
	self:LoadFakeOptions()
end

function myBigIgnite:dbVersionCheck()																		-- database version checking and updating
	if not mBI.db.global.dbVersion then
		if mBI.db.global.spellAura then
			for k1, v1 in pairs(mBI.db.global.spellAura) do
				if k1 ~= "combustion" and k1 ~= "ignite" then
					for k2, v2 in pairs(v1)	do
						if k2 == "enabled" then
							mBI.db.profile.spellTracking[k1].enabled = v2
						end
					end
				end
			end
			if mBI.db.global.spellAura.combustion ~= nil and mBI.db.global.spellAura.combustion.CDtracking ~= nil then
				mBI.db.profile.combuTracking.enabled = mBI.db.global.spellAura.combustion.CDtracking
			end
		end
		if mBI.db.global.igValue ~= nil then
			mBI.db.profile.values.igThreshold = tonumber(mBI.db.global.igValue)
		end
		if mBI.db.global.igPerct ~= nil then
			mBI.db.profile.values.igPerct = tonumber(mBI.db.global.igPerct)
		end
		wipe(mBI.db.global)
	mBI.db.global.dbVersion = 3
	end
	
	if mBI.db.global.dbVersion == 3 then
		if mBI.db.profile.mainFrame.autoHide == true then
			mBI.db.profile.mainFrame.hiding.noIgnite = true
			mBI.db.profile.mainFrame.hiding.noCombat = true
			mBI.db.profile.mainFrame.autoHide = nil
		end
		if mBI.db.profile.combuTracking ~= nil then
			if mBI.db.profile.combuTracking.inCDHide == true then
				mBI.db.profile.mainFrame.hiding.cCombuHiding = true
				mBI.db.profile.mainFrame.hiding.noCombat = true
				mBI.db.profile.mainFrame.hiding.cCombuHiding = true
			elseif mBI.db.profile.combuTracking.enabled ~= nil then
				mBI.db.profile.settings.combuTrack = mBI.db.profile.combuTracking.enabled
			end
			wipe(mBI.db.profile.combuTracking)
		end
		if mBI.db.profile.locale then
			mBI.db.profile.locale = nil
		end
		if mBI.db.profile.spellTracking then
			for k, v in pairs(mBI.db.profile.spellTracking) do
				if mBI.db.profile.spellTracking[k].enabled ~= nil then
					local temp = {}
					temp[k] = mBI.db.profile.spellTracking[k].enabled
					wipe(mBI.db.profile.spellTracking)
					if k ~= "pyroHS" then
						mBI.db.profile.spellTracking = deepCopy(mBI.defaults.profile.spellTracking)
						mBI.db.profile.spellTracking[k].enabled = temp[k]
					end
				end
			end
		end
	end
	
	if mBI.db.global.dbVersion ~= mBI.dbRev then
		mBI.db.global.dbVersion = mBI.dbRev
	end
end

function myBigIgnite:SpecCheck(event, ...)
	if IsSpellKnown(mBI.spellID.combustion) then															-- combustion spell id (not the dot)
		if not mBI.specFire then
			if not mBI.addonLoadded then																	-- first loadind of mBI
				self:mBILoad()
			else																							-- back into active state
				self:RegisterEvent("PLAYER_REGEN_DISABLED", "CombatCheck")
				self:RegisterEvent("PLAYER_REGEN_ENABLED", "CombatCheck")
				self:RegisterEvent("UI_SCALE_CHANGED", "ScaleChange")
				self:RegisterEvent("GLYPH_ADDED", "ffbGlyphCheck")
				self:RegisterEvent("GLYPH_REMOVED", "ffbGlyphCheck")
				self:RegisterChatCommand("myBigIgnite", "OpenConfig")
				self:RegisterChatCommand("mbi", "OpenConfig")
				mBI.igDmg = 0
				mBI.F.anchor:Show()
				self:CombuCheck()																			-- checks if Combustion in cd when reactivating mBI and starts timer if necessary
			end
			
			if mBI.configLoaded then																		-- config panel switches
				self:ChangeConfigDisplay("fireSpec")
			else
				self:ChangeConfigDisplay("unloadedConfig")
			end
			
			if mBI.db.profile.settings.splashMsg then
				print(mBI.cD .. L["myBigIgnite v"] .. mBI.addonV .. L[" loaded."])
			end
			if mBI.db.profile.values.igThreshold == 0 then
				print(mBI.cD .. L["myBigIgnite: "] .. mBI.cL .. L["notyetthreshold"])
			end
			
			if mBI.db.profile.mainFrame.hiding.noCombat then
				self:FrameFading(true)
			else
				self:FrameFading(false)
			end
			mBI.specFire = true
		end
		self:IsImpactKnown()
	else																									-- disabled state, unregistring events and hiding of mBI main frame
		if mBI.specFire then
			self:UnregisterEvent("PLAYER_REGEN_DISABLED")
			self:UnregisterEvent("PLAYER_REGEN_ENABLED")
			self:UnregisterEvent("UI_SCALE_CHANGED")
			self:UnregisterEvent("GLYPH_ADDED")
			self:UnregisterEvent("GLYPH_REMOVED")
			self:UnregisterChatCommand("myBigIgnite")
			self:UnregisterChatCommand("mbi")
			mBI.F.anchor:Hide()
			print(mBI.cD .. L["myBigIgnite is disabled."])
			mBI.specFire = false
		end
		
		self:ChangeConfigDisplay("ooFireSpec")																-- non fire spec config panel state
	end
end

function myBigIgnite:IsImpactKnown()																		-- checking whether impact is known
	for i = 1, GetNumTalents(2) do																			-- 2 is for talent tab n2 (fire)
		local name, _, _, _, rank = GetTalentInfo(2, i, false, false, nil)
		if name == mBI.impactName then
			if rank == 0 then
				mBI.impactKnown = false
			else
				mBI.impactKnown = true
			end
		end
	end
end

function myBigIgnite:CreateSpellTables()																	-- internal spell tables created from user's database
	if not mBI.addonLoadded then
		_, _, mBI.combuIcon = GetSpellInfo(mBI.spellID.combustion)
		_, _, mBI.fbIcon = GetSpellInfo(mBI.spellID.fireball)
		_, _, mBI.ffbIcon = GetSpellInfo(mBI.spellID.ffbolt)
		_, _, mBI.igniteIcon = GetSpellInfo(mBI.spellID.ignite)
		_, _, mBI.lbIcon = GetSpellInfo(mBI.spellID.livingBomb)
		_, _, mBI.fireblastIcon = GetSpellInfo(mBI.spellID.fireblast)
		mBI.impactName = GetSpellInfo(mBI.spellID.impact)
	end

	wipe(mBI.spellName)
	wipe(mBI.spellIcon)
	wipe(mBI.spellOrder)
	wipe(mBI.locName)

	local i = 1
	for k, v in pairs(mBI.db.profile.spellTracking) do
		if mBI.db.profile.spellTracking[k].enabled then
			if k == "pyroblast" then
				mBI.spellName[i], _, mBI.spellIcon[i] = GetSpellInfo(mBI.spellID.pyroHS)
				mBI.spellOrder[i] = mBI.db.profile.spellTracking[k].order
				mBI.locName.pyroHS = mBI.spellName[i]
				i = i + 1
			end
			mBI.spellName[i], _, mBI.spellIcon[i] = GetSpellInfo(mBI.spellID[k])
			mBI.spellOrder[i] = mBI.db.profile.spellTracking[k].order
			mBI.locName[k] = mBI.spellName[i]
			i = i + 1
		end
	end
end

function myBigIgnite:mBILoad()																				-- first loading
	self.db = LibStub("AceDB-3.0"):New("mBIsettings", mBI.defaults)										-- database loading / command line
	self:RegisterChatCommand("myBigIgnite","OpenConfig")
	self:RegisterChatCommand("mbi", "OpenConfig")
	
	--shared media stuff
	LSM:Register("border", "Solid", "Interface\\Buttons\\WHITE8X8")
	
	local texturesPath = "Interface\\Addons\\myBigIgnite\\bars\\"
	LSM:Register("statusbar", "Aluminum", texturesPath .. "Aluminum.tga")	
	LSM:Register("statusbar", "Armory", texturesPath .. "Armory.tga")
	LSM:Register("statusbar", "BantoBar", texturesPath .. "BantoBar.tga")
	LSM:Register("statusbar", "Charcoal", texturesPath .. "Charcoal.tga")
	LSM:Register("statusbar", "Flat", texturesPath .. "Flat.tga")
	LSM:Register("statusbar", "Frost", texturesPath .. "Frost.tga")
	LSM:Register("statusbar", "Glaze", texturesPath .. "Glaze.tga")
	LSM:Register("statusbar", "Gloss", texturesPath .. "Gloss.tga")
	LSM:Register("statusbar", "Graphite", texturesPath .. "Graphite.tga")
	LSM:Register("statusbar", "Healbot", texturesPath .. "Healbot.tga")
	LSM:Register("statusbar", "LiteStep", texturesPath .. "LiteStep.tga")
	LSM:Register("statusbar", "Minimalist", texturesPath .. "Minimalist.tga")
	LSM:Register("statusbar", "Otravi", texturesPath .. "Otravi.tga")
	LSM:Register("statusbar", "Perl", texturesPath .. "Perl.tga")
	LSM:Register("statusbar", "Rocks", texturesPath .. "Rocks.tga")
	LSM:Register("statusbar", "Runes", texturesPath .. "Runes.tga")
	LSM:Register("statusbar", "Shard", texturesPath .. "Shard.tga")
	LSM:Register("statusbar", "Smooth", texturesPath .. "Smooth.tga")
	LSM:Register("statusbar", "Striped", texturesPath .. "Striped.tga")
	LSM:Register("statusbar", "Xeon", texturesPath .. "Xeon.tga")
	
	-- event registring
	self:RegisterEvent("PLAYER_REGEN_DISABLED","CombatCheck")
	self:RegisterEvent("PLAYER_REGEN_ENABLED","CombatCheck")
	self:RegisterEvent("UI_SCALE_CHANGED", "ScaleChange")
	self:RegisterEvent("GLYPH_ADDED", "ffbGlyphCheck")
	self:RegisterEvent("GLYPH_REMOVED", "ffbGlyphCheck")
	
	self:dbVersionCheck()
	self:ffbGlyphCheck()																					-- ffb glyph detection													
	
	mBI.igDmg = 0
	mBI.font = LSM:Fetch("font", mBI.db.profile.mainFrame.textFont)
	
	self:CreateColorTables()																				-- color table creation
	self:CreateSpellTables()																				-- spell table creation
	self:CreateFrames()																						-- frame creation
	mBI.F.combat:SetScript("OnUpdate",  function(self, elapsed) myBigIgnite.OnUpdate(self, elapsed) end)
	
	-- combustion CD checking
	self:CombuCheck()
	
	mBI.addonLoadded = true
end


-------------------------------------------------------------------------------------------------------------------------------------------
-- Frame functions

function myBigIgnite:CreateColorTables()																	-- color tables for each type of display
	mBI.igT = {
		[1] = "high",
		[2] = "mid",
		[3] = "low",
		[4] = "impact",
	}
	mBI.elem = {
		[1] = "text",
		[2] = "bg",
		[3] = "bd",
	}
	for i = 1, #mBI.igT do
		mBI[mBI.igT[i] .. "Ig"] = {}
		for j = 1, #mBI.elem do
			mBI[mBI.igT[i] .. "Ig"][mBI.elem[j] .. "Color"] = {}
			for k, v in pairs(mBI.db.profile.mainFrame[mBI.igT[i] .. "Ig"][mBI.elem[j] .. "Color"]) do
				mBI[mBI.igT[i] .. "Ig"][mBI.elem[j] .. "Color"][k] = mBI.db.profile.mainFrame[mBI.igT[i] .. "Ig"][mBI.elem[j] .. "Color"][k]
			end
		end
	end
end

function myBigIgnite:SetFrameSize(field)																	-- sets the size of each frame (called using frame name as field)
	local width, height = 1, 1
	if field == "dmg" or field == "title" then
		mBI.F[field].txt:SetFont(mBI.font, mBI.db.profile.mainFrame.textSize, mBI.db.profile.mainFrame.lowIg.textFlag)
		if mBI.db.profile.mainFrame.textShadow then
			mBI.F[field].txt:SetShadowColor(0, 0, 0, 1)
			mBI.F[field].txt:SetShadowOffset(1, -1)
		else
			mBI.F[field].txt:SetShadowColor(0, 0, 0, 0)
		end
		if field == "dmg" then
			self:AlignText("dmg")
			mBI.F[field].txt:SetText(formatText(999999))
			width = mBI.F[field].txt:GetStringWidth() * 1.1
			height = mBI.F[field].txt:GetStringHeight() * 1.3
			mBI.F.dmg.w = width
			mBI.F.dmg.h = height
			mBI.F.dmg.txt:SetText(formatText(mBI.igDmg))
		else
			self:AlignText("title")
			mBI.F.title.txt:SetText(L["Ignite:"])
			width = mBI.F[field].txt:GetStringWidth() * 1.1
			height = mBI.F[field].txt:GetStringHeight() * 1.3
			mBI.F.title.w = width
		end
	elseif field == "icon" then
		if mBI.db.profile.titleFrame.enabled then
			height = mBI.F.dmg.h * 2
		else
			height = mBI.F.dmg.h
		end
		width = height * mBI.db.profile.iconFrame.sizeFactor
		mBI.F.icon.off = (height - width) / 2
		mBI.F.icon.w = width
		height = width
	elseif field == "main" then
		width = mBI.F.dmg.w
		height = mBI.F.dmg.h
		if mBI.db.profile.titleFrame.enabled then
			height = height * 2
			if mBI.F.title.w > mBI.F.dmg.w then
				width = mBI.F.title.w
			end
		end
		if mBI.db.profile.iconFrame.enabled then
			if mBI.db.profile.iconFrame.sizeFactor >= 1 then
				width = width + mBI.F.icon.w / mBI.db.profile.iconFrame.sizeFactor
			else
				width =  width + mBI.F.icon.w
			end
		end
		width = width * 1.1
		mBI.F.main.w = width
		mBI.F.main.h = height
	end
	mBI.F[field]:SetWidth(width)
	mBI.F[field]:SetHeight(height)
end

function myBigIgnite:SetFrameBackdrop(field)																-- sets frame backdrops
	if mBI.F[field] then
		local backdrop = {
			bgFile = LSM:Fetch("background", mBI.db.profile[field .. "Frame"].bgTexture) or "",
			edgeFile = LSM:Fetch("border", mBI.db.profile[field .. "Frame"].bdTexture) or "",
			edgeSize = mBI.db.profile[field .. "Frame"].bdSize,
			insets = {
				left = mBI.db.profile[field .. "Frame"].inset,
				right = mBI.db.profile[field .. "Frame"].inset,
				top = mBI.db.profile[field .. "Frame"].inset,
				bottom = mBI.db.profile[field .. "Frame"].inset,
			} or "",
		}
		
		if field == "main" and not mBI.db.profile[field .. "Frame"].bgEnabled then
			backdrop.bgFile = ""
		end
		if field == "main" and not mBI.db.profile[field .. "Frame"].bdEnabled then
			backdrop.edgeFile = ""
		end
		if field == "icon" then
			if string.find(mBI.db.profile[field .. "Frame"].type, "bord") then
			backdrop.edgeFile = LSM:Fetch("border", "Solid")
			else
				backdrop.edgeFile = ""
			end
		end
		mBI.F[field]:SetBackdrop(backdrop)
	end
end

function myBigIgnite:SetAnchorFrameStrata()																	-- anchor frame strata
	if mBI.db.profile.anchorFrame.strata == 1 then
		mBI.F.anchor:SetFrameStrata("LOW")
	elseif mBI.db.profile.anchorFrame.strata == 2 then
		mBI.F.anchor:SetFrameStrata("MEDIUM")
	else
		mBI.F.anchor:SetFrameStrata("HIGH")
	end
end

function myBigIgnite:SetAnchorFramePosition()																-- anchor frame position
	local UIScale = UIParent:GetScale()
	local UIWidth = UIParent:GetWidth()
	local UIHeight = UIParent:GetHeight()
	mBI.F.anchor:ClearAllPoints()
	mBI.F.anchor:SetPoint("CENTER", UIParent, "CENTER", mBI.db.profile.anchorFrame.coord.xcd / UIScale - UIWidth / 2 , mBI.db.profile.anchorFrame.coord.ycd / UIScale - UIHeight / 2)
end

function myBigIgnite:SetFramePoint(field, ...)																-- sets frame anchors
	local point, parent, relpoint, xcd, ycd = ...
	mBI.F[field]:ClearAllPoints()		
	if field == "title" or field == "dmg" then
		if point == "CENTER" then
			point = ""
			relpoint = ""
		end
		if mBI.db.profile.iconFrame.enabled then															-- puts title and dmg frame anchoring under the control of icon side if icon is displayed
			if mBI.db.profile.iconFrame.side == "LEFT" then
				point = "RIGHT"
				relpoint = "RIGHT"
			else
				point = "LEFT"
				relpoint = "LEFT"
			end
		end
		if field == "title" then
			point = "TOP" .. point
			relpoint = "TOP" .. relpoint
		elseif field == "dmg" then
			point = "BOTTOM" .. point
			relpoint = "BOTTOM" .. relpoint
		end
	elseif field == "icon" then
		if mBI.db.profile.iconFrame.side == "RIGHT" then
			xcd = -xcd
		end
	end
	mBI.F[field]:SetPoint(point, parent, relpoint, xcd, ycd)
end

function myBigIgnite:AlignText(field)																		-- text anchoring inside title and dmg frames
	mBI.F[field].txt:ClearAllPoints()
	local point, relpoint, ofx, ofy = mBI.db.profile.mainFrame.textAlign, mBI.db.profile.mainFrame.textAlign, mBI.db.profile.mainFrame.textOffsetX, mBI.db.profile.mainFrame.textOffsetY
	if not mBI.db.profile.iconFrame.enabled then
		if mBI.db.profile.mainFrame.textAlign == "CENTER" then
			ofx = 0
			if not mBI.db.profile.titleFrame.enabled then
				ofy = 0
			end
		end
	end
	if mBI.db.profile.iconFrame.enabled then																-- again, controlled by icon side if necessary
		if mBI.db.profile.iconFrame.side == "LEFT" then
			point = "RIGHT"
			relpoint = "RIGHT"
		else
			point = "LEFT"
			relpoint = "LEFT"
		end
	end
	if field == "title" then
		ofy = -ofy
	end
	if point == "RIGHT" then
		ofx = -ofx
	end
	mBI.F[field].txt:SetPoint(point, mBI.F[field], relpoint, ofx, ofy)
end

function myBigIgnite:SetFrameInteractive(field, movable, mouse)												-- mouse interaction
	mBI.F[field]:SetMovable(movable)
	mBI.F[field]:EnableMouse(mouse)
end

function myBigIgnite:SetIconType(field, iconType)															-- normal or zoomed icon
	mBI.F[field].tt:ClearAllPoints()
	if string.find(iconType, "zoom") then
		mBI.F[field].tt:SetTexCoord(0.08, 0.92, 0.08, 0.92)
	else
		mBI.F[field].tt:SetTexCoord(0, 1, 0, 1)
	end
	mBI.F[field].tt:SetAllPoints(mBI.F.icon)
end

function myBigIgnite:SetIconBorderColor(t)																	-- icon border color
	mBI.F.icon:SetBackdropBorderColor(getColor(t))
end

function myBigIgnite:CreateIconFrame()																		-- accessory creation of icon frame / allow on demand creation
	mBI.F.icon = CreateFrame("Frame", "mBI.F.icon", mBI.F.main)
	self:SetFrameSize("icon")
	self:SetFrameInteractive("icon", false, false)
	self:SetFramePoint("icon", mBI.db.profile.iconFrame.side, mBI.F.main, mBI.db.profile.iconFrame.side, mBI.F.icon.off, 0)
	mBI.F.icon.tt = mBI.F.icon:CreateTexture("mBI.F.icon.tt", "BACKGROUND")
	self:SetIconType("icon", mBI.db.profile.iconFrame.type)
	mBI.F.icon.tt:SetTexture(mBI.igniteIcon)
	self:SetFrameBackdrop("icon")
	self:SetIconBorderColor(mBI.db.profile.mainFrame.lowIg.bdColor)
	self:ffbStackDisplay()
end

function myBigIgnite:ffbStackDisplay()
	if mBI.ffbGlyph then
		mBI.F.icon.txt = mBI.F.icon:CreateFontString(nil, "OVERLAY")
		mBI.F.icon.txt:SetFont(mBI.font, mBI.F.icon.w * 0.6, "OUTLINE")
		mBI.F.icon.txt:SetPoint("BOTTOMRIGHT", mBI.F.icon, "BOTTOMRIGHT", 1, 1)
		mBI.ffbStackDisp = true
	end
end

function myBigIgnite:CreateTitleFrame()																		-- accessory creation of title frame / allow on demand creation
	mBI.F.title = CreateFrame("Frame", "mBI.F.title", mBI.F.main)
	mBI.F.title.txt = mBI.F.title:CreateFontString(nil, "OVERLAY")
	self:SetFrameSize("title")
	self:SetFrameInteractive("title", false, false)
	self:SetFramePoint("title", mBI.db.profile.mainFrame.textAlign, mBI.F.main, mBI.db.profile.mainFrame.textAlign, 0, 0)
end

function myBigIgnite:SetIgniteTimer(frame)
	local texture = LSM:Fetch("background", mBI.db.profile.mainFrame.bgTexture)
	if not mBI.db.profile.igniteTimer.useGeneralBackground then
		texture = LSM:Fetch("statusbar", mBI.db.profile.igniteTimer.texture)
	end
	frame:SetStatusBarTexture(texture)
	
	local inset = mBI.db.profile.mainFrame.inset
	frame:SetPoint("CENTER", mBI.F.dmg, "CENTER", mBI.db.profile.igniteTimer.ofx, mBI.db.profile.igniteTimer.ofy)
	-- frame:SetPoint("TOPRIGHT", mBI.F.dmg, "TOPRIGHT", mBI.db.profile.igniteTimer.ofx, mBI.db.profile.igniteTimer.ofy)
	
	frame:SetReverseFill(mBI.db.profile.igniteTimer.reverse)
		
	frame.w = mBI.F.dmg.w * mBI.db.profile.igniteTimer.mult
	frame.h = mBI.F.dmg.h * mBI.db.profile.igniteTimer.mult
	frame:SetWidth(frame.w)
	frame:SetHeight(frame.h)

	frame:SetScript("OnUpdate", function(_, elapsed)
		if frame.duration and frame.duration > 0 then
			frame.value = frame.value- elapsed
			frame:SetValue(frame.value)
		end
	end)
	
	frame:Hide()
	if mBI.cfMode then
		frame:Show()
	end
end

-- function myBigIgnite:CreateHudFrame()
	-- mBI.F.HUD = CreateFrame("Frame", "mBI.F.HUD", mBI.F.anchor)
	-- mBI.F.HUD:SetWidth(128)
	-- mBI.F.HUD:SetHeight(64)
	-- mBI.F.HUD:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	-- mBI.F.HUD.tt = mBI.F.HUD:CreateTexture("mBI.F.HUD.tt", "BACKGROUND")
	-- mBI.F.HUD.tt:SetTexture("Interface\\Addons\\myBigIgnite\\textures\\default.tga")
	-- mBI.F.HUD.tt:SetAllPoints(mBI.F.HUD)
	-- mBI.F.HUD.tt:SetVertexColor(0, 1, 0, 1)
	-- local backdrop= {
			-- bgFile = "Interface\\Addons\\myBigIgnite\\textures\\default.tga",
			-- edgeFile = "",
			-- tile = false,
			-- tileSize = 16,
			-- edgeSize = 0,
			-- insets = {
				-- left = 0,
				-- right = 0,
				-- top = 0,
				-- bottom = 0,
			-- },
	-- }
	
	-- mBI.F.HUD:SetBackdrop(backdrop)
	-- mBI.F.HUD:SetBackdropColor(0.5, 0.5, 1)
-- end

function myBigIgnite:CreateFrames()																			-- mBI frame creation
	local UIScale = UIParent:GetScale()
	local UIWidth = UIParent:GetWidth()
	local UIHeight = UIParent:GetHeight()
	
	mBI.F.anchor = CreateFrame("Frame", "mBI.F.anchor", UIParent)											-- anchor frame, parent of all others
	self:SetFrameSize("anchor")
	self:SetFrameInteractive("anchor", false, false)
	self:SetAnchorFramePosition()
	self:SetAnchorFrameStrata()

	mBI.F.main = CreateFrame("Frame", "mBI.F.main", mBI.F.anchor)											-- main frame
	self:SetFramePoint("main", mBI.db.profile.mainFrame.align, mBI.F.anchor, "CENTER")
	self:SetFrameInteractive("main", false, false)
	self:SetFrameBackdrop("main")
	
	mBI.F.dmg = CreateFrame("Frame", "mBI.F.dmg", mBI.F.main)												-- dmg display frame
	mBI.F.dmg.txt = mBI.F.dmg:CreateFontString(nil, "OVERLAY")
	self:SetFrameSize("dmg")
	self:SetFramePoint("dmg", mBI.db.profile.mainFrame.textAlign, mBI.F.main, mBI.db.profile.mainFrame.textAlign, 0, 0)
	self:SetFrameInteractive("dmg", false, false)
	
	if mBI.db.profile.igniteTimer.enabled then
		mBI.F.igniteTimer = CreateFrame("StatusBar", nil, mBI.F.main)	
		self:SetIgniteTimer(mBI.F.igniteTimer)
	end
	
	if mBI.db.profile.iconFrame.enabled then																-- accessory frames
		self:CreateIconFrame()
	end
	if mBI.db.profile.titleFrame.enabled then
		self:CreateTitleFrame()
	end	
	-- if mBI.db.profile.hudFrame.enabled then
		-- self:CreateHudFrame()
	-- end
	
	mBI.F.combat = CreateFrame("Frame", "mBI.F.combat", mBI.F.anchor)										-- on update frame
	self:SetFrameInteractive("combat", false, false)
	mBI.F.combat:SetPoint("CENTER", mBI.F.anchor, "CENTER", 0, 0)
	mBI.F.combat:Hide()
	
	self:SetFrameSize("main")
	self:UpdateDisplay("low")
end


-------------------------------------------------------------------------------------------------------------------------------------------
-- display control functions

function myBigIgnite:FrameFading(bool)																		-- autohiding
	if bool then
		mBI.F.main:Hide()
	else
		mBI.F.main:Show()
	end
end

function myBigIgnite:UpdateDisplay(igtype, iconpath, redzone)												-- called each refresh
	local mult = mBI.db.profile.mainFrame[igtype .. "Ig"].mult or 1
	local txtSize = mBI.db.profile.mainFrame.textSize * mult
	local isVisualRZ = false
	local iconPath = iconpath or mBI.lbIcon
	
	if redzone and igtype ~= "low" then																		-- red zone handling, color of each type of display is of the red zone if visual red zone is enabled. color of calor tables is changed here
		if mBI.db.profile.settings.lagVisual then
			for i = 1, #mBI.elem do
				if mBI.db.profile.settings.lagVisualType[mBI.elem[i]] then
					for k, v in pairs(mBI[igtype .. "Ig"][mBI.elem[i] .."Color"]) do
						if mBI.db.profile.settings.lagColor[k] ~= nil then
							mBI[igtype .. "Ig"][mBI.elem[i] .. "Color"][k] = mBI.db.profile.settings.lagColor[k]
						end
					end
				end
			end
			isVisualRZ = true
		else
			self:UpdateDisplay("low", iconPath)																-- no visual red zone
			return
		end
	end
	if mBI.wasVisualRZ and not isVisualRZ then																-- back to default state when red zone is over and visual red zone is enabled
		for i = 1, #mBI.elem do
			if mBI.db.profile.settings.lagVisualType[mBI.elem[i]] then
				for k, v in pairs(mBI[igtype .. "Ig"][mBI.elem[i] .."Color"]) do
					mBI[igtype .. "Ig"][mBI.elem[i] .."Color"][k] = mBI.db.profile.mainFrame[igtype .. "Ig"][mBI.elem[i] .."Color"][k]
				end
			end
		end
	end
		
	if mBI.db.profile.titleFrame.enabled then																-- title frame
		mBI.F.title.txt:SetTextColor(getColor(mBI[igtype .. "Ig"].textColor))
		mBI.F.title.txt:SetFont(mBI.font, txtSize, mBI.db.profile.mainFrame[igtype .. "Ig"].textFlag)
		mBI.F.title:SetWidth(mBI.F.title.w * mult)
		mBI.F.title:SetHeight(mBI.F.dmg.h * mult)
	end
	if mBI.db.profile.iconFrame.enabled then																-- icon frame
		mBI.F.icon:SetWidth(mBI.F.icon.w * mult)
		mBI.F.icon:SetHeight(mBI.F.icon.w * mult)
		self:SetFramePoint("icon", mBI.db.profile.iconFrame.side, mBI.F.main, mBI.db.profile.iconFrame.side, mBI.F.icon.off * mult, 0)
		if string.find(mBI.db.profile.iconFrame.type, "bord") then
			self:SetIconBorderColor(mBI[igtype .. "Ig"].bdColor)
		end
		if mBI.db.profile.iconFrame.dynamic then
			mBI.F.icon.tt:SetTexture(iconPath)
		end
	end
	if mBI.db.profile.igniteTimer.enabled then
		mBI.F.igniteTimer:SetHeight(mBI.F.igniteTimer.h * mult)
		mBI.F.igniteTimer:SetWidth(mBI.F.igniteTimer.w * mult)
	end
	
	if mBI.db.profile.mainFrame.bgEnabled then																-- background
		mBI.F.main:SetBackdropColor(getColor(mBI[igtype .. "Ig"].bgColor))		
	end
	if mBI.db.profile.mainFrame.bdEnabled then																-- border
		mBI.F.main:SetBackdropBorderColor(getColor(mBI[igtype .. "Ig"].bdColor))
	end
	mBI.F.dmg.txt:SetFont(mBI.font, txtSize, mBI.db.profile.mainFrame[igtype .. "Ig"].textFlag)			-- dmg
	mBI.F.dmg.txt:SetTextColor(getColor(mBI[igtype .. "Ig"].textColor))
		
	mBI.F.dmg:SetWidth(mBI.F.dmg.w * mult)																	-- frame size
	mBI.F.dmg:SetHeight(mBI.F.dmg.h * mult)
	mBI.F.main:SetWidth(mBI.F.main.w * mult)
	mBI.F.main:SetHeight(mBI.F.main.h * mult)
	
	if isVisualRZ then
		mBI.wasVisualRZ = true
	end
end

-- ignite timer bar display
function myBigIgnite:UpdateIgniteTimerDisplay(igtype, igRemain)
	local r, g, b
	local a = mBI.db.profile.igniteTimer.alpha
	if igRemain > mBI.db.profile.igniteTimer.redZone then
		if not mBI.db.profile.igniteTimer.specificColor.enabled then
			r, g, b = getColor(mBI[igtype .. "Ig"].bgColor)
		else
			r, g, b = getColor(mBI.db.profile.igniteTimer.specificColor.color)
		end
	else
		r, g, b = getColor(mBI.db.profile.igniteTimer.redZoneColor)
	end
	mBI.F.igniteTimer:SetStatusBarColor(r, g, b, a)
end



-------------------------------------------------------------------------------------------------------------------------------------------
-- On event functions

function myBigIgnite:ffbGlyphCheck(event)																	-- ffb glyph detection
	mBI.ffbGlyph = false
	for i = 1, NUM_GLYPH_SLOTS do
		local enabled, glyphType, _, glyphID = GetGlyphSocketInfo(i)
		if enabled and glyphType == 3 then																	-- 3 is for prime glyphs
			if glyphID and glyphID == 61205	then															-- ffb glyph id
				mBI.ffbGlyph = true
				if not mBI.ffbStackDisp and mBI.F.icon then
					self:ffbStackDisplay()
				end
			end
		end
	end
end

function myBigIgnite:ScaleChange()																			-- UI scale change detection
	local UIScale = UIParent:GetScale()
	mBI.db.profile.anchorFrame.coord.xcd = mBI.F.anchor:GetLeft() * UIScale
	mBI.db.profile.anchorFrame.coord.ycd = mBI.F.anchor:GetBottom() * UIScale
	if mBI.configLoaded then
		wipe(mBI.options.args)
		self:LoadFireOptions()
		self:ChangeConfigDisplay("fireSpec")
	end
end

function myBigIgnite:CombuCheck()																			-- Combustion CD check function
	if mBI.db.profile.settings.combuTrack then
		local startCD, durationCD = GetSpellCooldown(mBI.spellID.combustion)
		local time = GetTime()
		if time > startCD + durationCD then
			mBI.combuCD = false
			mBI.combuCDTime = 0
		else
			mBI.combuCD = true
			mBI.combuCDTime = startCD + durationCD - time
			mBI.F.combat:Show()
		end
	end
end

function myBigIgnite:CombatCheck(event)																		-- Combat check function
	if event == "PLAYER_REGEN_DISABLED" then
		mBI.F.combat:Show()
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatEvent")
		mBI.inCombat = true
		ACR:NotifyChange("myBigIgnite")
	else
		mBI.inCombat = false
		ACR:NotifyChange("myBigIgnite")
	end
end

function myBigIgnite:CombatEvent(WOWevent, ...)																-- Combat event handler
	if mBI.db.profile.values.igThreshold ~= 0 then
		local _, eventType, _, sourceGUID, _, _, _, destGUID, _, _, _, spellID, _, _, amount, _ = ...
		local pGUID = UnitGUID("player")
		local tGUID = UnitGUID("target")
		if sourceGUID == pGUID and destGUID == tGUID then
			if string.find(eventType, "_DAMAGE") and spellID == mBI.spellID.ignite then
				mBI.igDmg = amount
			end
		end
	else
		mBI.warning = true
	end
end


-------------------------------------------------------------------------------------------------------------------------------------------
-- On update code

do
	local timeBeforeStopReg = 5
	function myBigIgnite:OnUpdate(elapsed)
		self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed
		if (self.TimeSinceLastUpdate > mBI.db.profile.settings.refresh) then
			local time = GetTime()
			local notPyro, notPyroHS = false, false
			local igType = "low"
			local redZone = false
			local isDotAbsent, isImpact = false, false
			local smoIndex = 0
			local spellIconPath = mBI.fbIcon
			local isTarget = UnitGUID("target")
			local remainTimeImpact = 0
			local igDuration = 0
			local igRemain = 0
			if mBI.db.profile.iconFrame.filler == "ffb" then
				spellIconPath = mBI.ffbIcon
			end
			
			for i = 1, #mBI.spellName do																	-- check time remaining specifically for defined spells
				local _, _, _, count, _, duration, expTime, _, _, _, _ = UnitAura("target", mBI.spellName[i], nil, "PLAYER|HARMFUL")
				if expTime ~= nil then
					mBI.remainTime[i] = expTime - time
					if mBI.remainTime[i] <= 0 then
						mBI.remainTime[i] = 0
					end
				else
					mBI.remainTime[i] = 0
				end

				if mBI.remainTime[i] > mBI.db.profile.settings.refresh then									-- checks if time > refresh of each DoT + handling of redZone
					if mBI.spellName[i] == mBI.locName.ffbolt and mBI.ffbGlyph then
						if count < 3 then
							isDotAbsent = true
							spellIconPath = mBI.spellIcon[i]
							mBI.F.icon.txt:SetText("+" .. 3 - count)
							mBI.F.icon.txt:Show()
						else
							mBI.F.icon.txt:Hide()
						end
					end
					
					if mBI.remainTime[i] <= mBI.db.profile.settings.lag then
						redZone = true
					end
				else
					if mBI.spellName[i] == mBI.locName.ffbolt and mBI.ffbGlyph then
						spellIconPath = mBI.spellIcon[i]
						mBI.F.icon.txt:SetText("+3")
						mBI.F.icon.txt:Show()
					end
					if mBI.spellName[i] == mBI.locName.pyroblast then
						notPyro = true
					end
					if mBI.spellName[i] == mBI.locName.pyroHS then
						notPyroHS = true
					end
					
					if (notPyro and notPyroHS) or (mBI.spellName[i] ~= mBI.locName.pyroblast and mBI.spellName[i] ~= mBI.locName.pyroHS) then
						isDotAbsent = true
						if smoIndex == 0 then
							spellIconPath = mBI.spellIcon[i]
							smoIndex = i
						else
							if spellIconPath ~= mBI.spellIcon[i] then
								if mBI.spellOrder[i] < mBI.spellOrder[smoIndex] then
									spellIconPath = mBI.spellIcon[i]
									smoIndex = i
								end
							end
						end
					end
				end						
				
				if mBI.spellName[i] == mBI.locName.ignite then												-- ignite dmg display coupled with on update
					igRemain = mBI.remainTime[i]
					igDuration = duration
					if mBI.db.profile.mainFrame.hiding.combuCD and mBI.combuCD and mBI.combuCDTime > mBI.db.profile.mainFrame.hiding.combuCDTime then
						myBigIgnite:FrameFading(true)
					elseif mBI.remainTime[i] < mBI.db.profile.settings.refresh and mBI.db.profile.mainFrame.hiding.noIgnite then
						myBigIgnite:FrameFading(true)
					else
						myBigIgnite:FrameFading(false)
					end
					if mBI.remainTime[i] < mBI.db.profile.settings.refresh then
						mBI.igDmg = 0
						igDduration = 0
						igRemain = 0
					end
					mBI.F.dmg.txt:SetText(formatText(mBI.igDmg))
				end

				i = i + 1
			end
			
			if not isTarget and mBI.db.profile.mainFrame.hiding.noCombat then								-- hides the frame if display w/o ignite is enabled but player has no target
				myBigIgnite:FrameFading(true)
			end
			
			myBigIgnite:CombuCheck()																		-- get combustion CD remaining
						
			if mBI.db.profile.settings.impactMode and mBI.impactKnown then									-- Impact tracking
				local _, _, _, _, _, _, expTimeImpact = UnitAura("player", mBI.impactName, nil, "PLAYER|HELPFULL")
				if expTimeImpact ~= nil then
					remainTimeImpact = expTimeImpact - time
					if remainTimeImpact <= 0 then
						remainTimeImpact = 0
					end
				end

				if remainTimeImpact > mBI.db.profile.settings.refresh then
					isImpact = true
				end
			end
				
			if not mBI.combuCD and not isDotAbsent then														-- updates frame display in function of DoTs / ignite dmg
				if mBI.igDmg >= mBI.db.profile.values.igThreshold then
					igType = "high"
					spellIconPath = mBI.combuIcon
				elseif mBI.igDmg >= mBI.db.profile.values.igThreshold * mBI.db.profile.values.igPerct and mBI.db.profile.values.igPerctEnabled then
					igType = "mid"
					spellIconPath = mBI.combuIcon
				else
					if mBI.db.profile.settings.impactMode and mBI.impactKnown and isImpact then
						if mBI.igDmg >= mBI.db.profile.values.igThreshold * mBI.db.profile.values.impactPerct and mBI.db.profile.values.impactPerctEnabled then
							igType = "impact"
						end						
						if mBI.db.profile.iconFrame.impactIcon then
							spellIconPath = mBI.fireblastIcon
						end
					end
				end
			elseif mBI.combuCD and mBI.db.profile.settings.impactMode and mBI.impactKnown and isImpact and not isDotAbsent then
				if mBI.igDmg >= mBI.db.profile.values.igThreshold * mBI.db.profile.values.impactPerct and mBI.db.profile.values.impactPerctEnabled then
					igType = "impact"
				end
				if mBI.db.profile.iconFrame.impactIcon then
					spellIconPath = mBI.fireblastIcon
				end
			end
			myBigIgnite:UpdateDisplay(igType, spellIconPath, redZone)
			
			-- ignite timer bar
			if mBI.db.profile.igniteTimer.enabled then
				if igRemain > mBI.db.profile.settings.refresh then
					mBI.F.igniteTimer.duration = igDuration
					mBI.F.igniteTimer.value = igRemain
					mBI.F.igniteTimer:SetMinMaxValues(0, igDuration)
					mBI.F.igniteTimer:SetValue(igRemain)
					myBigIgnite:UpdateIgniteTimerDisplay(igType, igRemain)
					mBI.F.igniteTimer:Show()
				else
					mBI.F.igniteTimer.duration = 0
					mBI.F.igniteTimer:Hide()
				end
			end
			
			if not mBI.inCombat then																		-- stops the on update code after 5 sec out of combat / no combustion in CD
				if mBI.db.profile.mainFrame.hiding.noCombat and not mBI.cfMode then
					myBigIgnite:FrameFading(true)
				else
					myBigIgnite:FrameFading(false)
				end
				myBigIgnite:UpdateDisplay(igType)
				if not mBI.combuCD then				
					timeBeforeStopReg = timeBeforeStopReg - mBI.db.profile.settings.refresh
					if timeBeforeStopReg < 0 then
						mBI.F.combat:Hide()
						self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
						if mBI.warning then
							print(mBI.cD .. L["myBigIgnite: "] .. mBI.cL .. L["notyetthreshold"])
							UIErrorsFrame:AddMessage(mBI.cD .. L["notyetthreshold"])
						end
						timeBeforeStopReg = 5
					end
				end
			end
			
			self.TimeSinceLastUpdate = 0
		end
	end
end

